<!-- 设备台账管理列表页 -->
<script name="EquipmentInfoBookList" setup lang="ts">
import type { Ref } from 'vue'
import { getCurrentInstance, onMounted, ref, watch } from 'vue'
import type { DateModelType } from 'element-plus'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import dayjs from 'dayjs'
import type { IList, IListQuery } from './book-interface'
import delReasonDialog from './dialog/delReasonDialog.vue'
import { approvalDelete, cancelApproval, draftDelete, getEquipmentList, refuseApproval, submit } from '@/api/equipment/info/book'
import ApprovalDialog from '@/components/Approval/ApprovalDialog.vue'
import type { deptType } from '@/global'
import buttonBox from '@/components/buttonBox/buttonBox.vue'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { getDictByCode } from '@/api/system/dict'
import { SCHEDULE } from '@/utils/scheduleDict'
import { getDeptTreeList } from '@/api/system/dept'
import { getStaffList } from '@/api/resource/register'
import { toTreeList } from '@/utils/structure'
import type { IMenu } from '@/components/buttonBox/buttonBox'

const $router = useRouter()
const active = ref('')
const operateWidth = ref('150') // 操作栏的宽度
const buttonBoxActive = 'equipmentInfoBook' // 存储在sessionstorage里面的字段名，用于记录右上角buttonbox点击状态
const approvalDialog = ref() // 审批对话ref
const delRef = ref() // 删除弹窗组件ref
// 查询条件
const listQuery: Ref<IListQuery> = ref({
  approvalStatus: active.value, // 审批状态
  deptId: '', // 所属部门id
  directorId: '', // 负责人id
  equipmentNo: '', // 统一编号
  equipmentName: '', // 设备名称
  formId: SCHEDULE.EQUIPMENT_BOOK_APPROVAL, // 表单id
  manufactureNo: '', // 出厂编号
  traceCompany: '', // 溯源单位
  measureValidDateEnd: '', // 检定有效期(结束)
  measureValidDateStart: '', // 检定有效期(开始)
  offset: 1,
  limit: 20,
})
const total = ref(0) // 数据条数
const loadingTable = ref(false) // 表格loading
const menu = ref<IMenu[]>([]) // 审批状态按钮组合
// 表头
const columns = ref<TableColumn[]>([
  { text: '统一编号', value: 'equipmentNo', align: 'center', width: '160' },
  { text: '设备名称', value: 'equipmentName', align: 'center' },
  { text: '型号规格', value: 'model', align: 'center' },
  { text: '设备单价（万元）', value: 'unitPrice', align: 'center' },
  { text: '生产厂家', value: 'manufacturer', align: 'center' },
  { text: '出厂编号', value: 'manufactureNo', align: 'center' },
  { text: '所属部门', value: 'deptName', align: 'center' },
  { text: '负责人', value: 'directorName', align: 'center', width: '120' },
  { text: '使用状态', value: 'usageStatusName', align: 'center', width: '90' },
  { text: '检定有效期', value: 'measureValidDate', align: 'center', width: '120' },
  { text: '溯源单位', value: 'traceCompany', align: 'center' },
])
const list = ref<IList[]>([]) // 表格数据
const dateRange = ref<[DateModelType, DateModelType]>(['', ''])// 筛选时间段数据
const checkoutList = ref<string[]>([])// 选中的内容

// -----------------------------------------字典--------------------------------------------------------------
const useDeptList = ref<deptType[]>([]) // 所属部门列表
const userList = ref<{ [key: string]: string }[]>([]) // 用户列表

// 查询字典
const getDict = async () => {
  loadingTable.value = true
  // 审批状态
  const res = await getDictByCode('approvalStatus')
  // 制作右上角的菜单
  const tempMenu = ['全部', '已审批', '待审批', '审批', '草稿箱', '审批中', '已通过', '未通过', '已取消']
  tempMenu.forEach((item) => {
    const tempFindData = res.data.find((e: { name: string; value: string }) => e.name === item)
    if (tempFindData) {
      menu.value.push({
        name: tempFindData.name,
        id: `${tempFindData.value}`,
      })
    }
  })

  // 获取部门列表
  getDeptTreeList().then((res) => {
    // 转成树结构
    useDeptList.value = toTreeList(res.data, '0', true)
  })
  // 获取用户列表
  getStaffList({ offset: 1, limit: 999999 }).then((res: any) => {
    userList.value = res.data.rows
  })
}
// -------------------------------------------------------------------------------------------------------
// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  getEquipmentList(listQuery.value).then((response) => {
    list.value = response.data.rows.map((item: { estimateSignDate: string; agreementAmount: number; measureValidDate: string }) => {
      return {
        ...item,
        measureValidDate: item.measureValidDate ? dayjs(item.measureValidDate).format('YYYY-MM-DD') : item.measureValidDate,
      }
    })
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  }).catch(() => {
    loadingTable.value = false
  })
}
// 搜索
const searchList = () => {
  fetchData(true)
}

// 重置
const clearList = () => {
  listQuery.value = {
    approvalStatus: active.value, // 审批状态
    deptId: '', // 所属部门id
    directorId: '', // 负责人id
    equipmentNo: '', // 统一编号
    equipmentName: '', // 设备名称
    formId: SCHEDULE.EQUIPMENT_BOOK_APPROVAL, // 表单id
    manufactureNo: '', // 出厂编号
    traceCompany: '', // 溯源单位
    measureValidDateEnd: '', // 检定有效期(开始)
    measureValidDateStart: '', // 检定有效期(结束)
    offset: 1,
    limit: 20,
  }
  dateRange.value = ['', '']
  fetchData(true)
}

// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}

// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}

// ---------------------------------------审批按钮---------------------------------------------------------------------
// 切换tab状态
const changeCurrentButton = (val: string) => {
  active.value = val // 此时的tab
  window.sessionStorage.setItem(buttonBoxActive, val) // 记录tab状态
  clearList() // 刷新
}
// 审批结束回调
const approvalSuccess = () => {
  fetchData(true)
}
// -------------------------------------表格上方工具栏-----------------------------------
// 模板下载
const templateDownload = () => {
  // useTemplateDownload('')
  ElMessage.info('敬请期待')
}
const fileRef = ref() // 文件上传input
const onFileChange = (event: any) => {
  // 原生上传
  if (event.target.files?.length !== 0) {
    // 创建formdata对象
    const fd = new FormData()
    fd.append('multipartFile', event.target.files[0])
    const loading = ElLoading.service({
      lock: true,
      background: 'rgba(255, 255, 255, 0.8)',
    })
    // 调批量导入接口
  }
}
// 批量导入
const batchImport = () => {
  ElMessage.info('敬请期待')
  // fileRef.value.click()
}

// 导出word
const exportWord = () => {
  ElMessage.info('敬请期待')
}

// 导出excel
const exportExcel = () => { ElMessage.info('敬请期待') }

// 新建
const add = () => {
  $router.push({ path: '/equipmentInfo/add' })
}
// ----------------------------------------------扫描----------------------------------------------------
// 点击扫描
const scan = () => { ElMessage.info('敬请期待') }

// ----------------------------------------------操作---------------------------------------------------
const handleEdit = (row: IList, type: string) => {
  if (type === 'edit' || type === 'detail') { // 编辑、详情
    $router.push({
      path: `/equipmentInfo/${type}/${row.id}`,
      query: {
        approvalStatusName: active.value === '0' ? '全部' : active.value === '7' ? '已审批' : row.approvalStatusName, // 审批状态名称
        equipmentNo: row.equipmentNo, // 设备编号
        processId: row.processId, // 流程实例id
        taskId: row.taskId, // 任务id
      },
    })
  }
  else if (type === '同意') {
    approvalDialog.value.initDialog('agree', row.taskId)
  }
  else if (type === '拒绝') {
    approvalDialog.value.initDialog('refuse', row.taskId, row.id)
  }
  else if (type === '取消') {
    const params = {
      processInstanceId: row.processId!,
      comments: '',
      id: row.id,
    }
    ElMessageBox.confirm(
      '确认取消该审批吗？',
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    )
      .then(() => {
        cancelApproval(params).then((res) => {
          ElMessage({
            type: 'success',
            message: '已取消',
          })
          fetchData(true)
        })
      })
  }
  else {
    ElMessageBox.confirm(
      `确认${type}吗？`,
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    ).then(() => {
      if (type === '删除' && row.approvalStatusName === '草稿箱') {
        draftDelete({ id: row.id }).then(() => {
          ElMessage.success(`已${type}`)
          fetchData()
        })
      }
      else if (type === '删除' && row.approvalStatusName === '已取消') {
        approvalDelete({ id: row.id, taskId: row.taskId }).then(() => {
          ElMessage.success(`已${type}`)
          fetchData()
        })
      }
      else if (type === '删除' && active.value === '0') { // 全部的删除
        delRef.value.initDialog(row)
      }
    })
  }
}
// 拒绝
const refuse = (comments: string, taskId: string, id: string) => {
  const params = {
    id,
    taskId, // 任务id
    comments, // 拒绝原因
  }
  refuseApproval(params).then((res) => {
    ElMessage({
      type: 'success',
      message: '已拒绝',
    })
    fetchData(true)
  })
}
// ----------------------------------------------钩子------------------------------------------------------
watch(dateRange, (val) => {
  if (val) {
    listQuery.value.measureValidDateStart = `${val[0]}`
    listQuery.value.measureValidDateEnd = `${val[1]}`
  }
  else {
    listQuery.value.measureValidDateStart = ''
    listQuery.value.measureValidDateEnd = ''
  }
})
onMounted(async () => {
  await getDict()
  if (window.sessionStorage.getItem(buttonBoxActive)) {
    active.value = window.sessionStorage.getItem(buttonBoxActive)!
  }
  else {
    active.value = menu.value.find(item => item.name === '全部')!.id as string // 全部
  }
})
</script>

<template>
  <app-container>
    <search-area :need-clear="true" @search="searchList" @clear="clearList">
      <search-item>
        <el-input v-model.trim="listQuery.equipmentNo" placeholder="统一编号" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.equipmentName" placeholder="设备名称" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.manufactureNo" placeholder="出厂编号" class="short-input" clearable />
      </search-item>
      <search-item>
        <dept-select
          v-model="listQuery.deptId"
          :data="useDeptList"
          placeholder="所属部门"
          class="short-input"
        />
      </search-item>
      <search-item>
        <el-select
          v-model="listQuery.directorId"
          placeholder="负责人"
          class="short-input"
          filterable
        >
          <el-option v-for="item in userList" :key="item.id" :label="item.staffName" :value="item.id" />
        </el-select>
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.traceCompany" placeholder="溯源单位" class="short-input" clearable />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="dateRange"
          class="short-input"
          type="daterange"
          range-separator="至"
          format="YYYY-MM-DD"
          value-format="YYYY-MM-DD"
          start-placeholder="检定有效期(开始)"
          end-placeholder="检定有效期(结束)"
        />
      </search-item>
    </search-area>

    <table-container>
      <template #btns-right>
        <icon-button v-if="active === '0'" icon="icon-word" title="导出word" type="primary" @click="exportWord" />
        <icon-button v-if="active === '0'" icon="icon-excel" title="导出excel" type="primary" @click="exportExcel" />
        <icon-button v-if="active === '0'" icon="icon-scan" title="扫描" type="primary" @click="scan" />
        <icon-button v-if="active === '0'" icon="icon-add" title="新建" type="primary" @click="add" />
        <!-- <icon-button v-if="proxy.hasPerm('/equipment/info/book/import')" icon="icon-import" title="批量导入" type="primary" @click="uploadAll" /> -->
        <icon-button v-if="active === '0'" icon="icon-import" title="批量导入" type="primary" @click="batchImport" />
        <!-- <icon-button v-if="proxy.hasPerm('/equipment/info/book/import')" icon="icon-template" title="模板下载" type="primary" @click="templateDownload" /> -->
        <icon-button v-if="active === '0'" icon="icon-template" title="模板下载" type="primary" @click="templateDownload" />
      </template>
      <input v-show="false" ref="fileRef" type="file" accept="*" @change="onFileChange">
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="loadingTable"
        is-showmulti-select @change="changePage" @multi-select="handleSelectionChange"
      >
        <template #preColumns>
          <el-table-column label="序号" width="55" align="center">
            <template #default="scope">
              {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
        <template #columns>
          <el-table-column
            label="操作"
            align="center"
            fixed="right"
            :width="operateWidth"
          >
            <template #default="{ row }">
              <el-button
                v-if="active !== '1' && active !== '6' && active !== '5'"
                size="small"
                type="primary"
                link
                @click="handleEdit(row, 'detail')"
              >
                查看
              </el-button>
              <el-button
                v-if=" active === '1' || active === '6' || active === '5'"
                size="small"
                type="primary"
                link
                @click="handleEdit(row, 'edit')"
              >
                查看
              </el-button>
              <el-button
                v-if="row.approvalStatusName === '待审批'"
                size="small"
                link
                type="primary"
                @click="handleEdit(row, '同意')"
              >
                同意
              </el-button>
              <el-button
                v-if="row.approvalStatusName === '待审批'"
                size="small"
                link
                type="danger"
                @click="handleEdit(row, '拒绝')"
              >
                拒绝
              </el-button>
              <el-button
                v-if="active === '0'"
                size="small"
                link
                type="primary"
                @click="handleEdit(row, 'edit')"
              >
                编辑
              </el-button>

              <!-- 是发起者且审批中可以取消 -->
              <el-button
                v-if="row.approvalStatusName === '审批中' && active !== '7' && active !== '0'"
                size="small"
                link
                type="info"
                @click="handleEdit(row, '取消')"
              >
                取消
              </el-button>
              <el-button
                v-if="active !== '7' && (active === '0' || row.approvalStatusName === '草稿箱' || row.approvalStatusName === '已取消')"
                size="small"
                link
                type="danger"
                @click="handleEdit(row, '删除')"
              >
                删除
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
    <!-- 审批弹窗 -->
    <approval-dialog ref="approvalDialog" @on-success="approvalSuccess" @refuse="refuse" />
    <!-- 右上角按钮集合 -->
    <button-box :active="active" :menu="menu" @change-current-button="changeCurrentButton" />
    <!-- 删除弹窗 -->
    <del-reason-dialog ref="delRef" @on-success="fetchData(true)" />
  </app-container>
</template>

<style lang="ts" scoped>

</style>
